c**********************************************************************
c
c**********************************************************************
      Subroutine SvFile(ifile, fname, IntFil, Title, PrgNam, Method,
     1      nCycle, Dump, ramda1, ramda2, QRange, IRatio,
     2      CalcX0, CalcX1, OptX0, OptX1, Back, idBack,
     3      nPeak, nOData, Angle, Height, GFrac, Gfwhm, Lfwhm,
     4      rfwhm, Aniso, XOrg, YOrg, idAng, idHei, idGFra, idGfwh,
     5      idLfwh, idrfwh, idAnis, OAngle, OHeigh, OGFrac, OGfwhm,
     6      OLfwhm, Orfwhm, OAniso, OBack, DifEPS)
      Include 'xPeakFit.prm'      
      Include 'xPeakFit.cmn'
      Integer ifile, nCycle
      Real Dump
      Character*(*) fname
      Character*(*) Title, PrgNam, Method, IntFil
      Real ramda1, ramda2, QRange, IRatio
      Real CalcX0, CalcX1, OptX0, OptX1
      Real Back(*)
      Integer idBack(*), nPeak, nOData
      Real Angle(*), Height(*), GFrac(*), Gfwhm(*), Lfwhm(*), rfwhm(*)
      Real Aniso(*), XOrg(*), YOrg(*)
      Integer idAng(*), idHei(*), idGFra(*), idGfwh(*), idLfwh(*)
      Integer idrfwh(*), idAnis(*)
      Real OAngle(*), OHeigh(*), OGFrac(*), OGfwhm(*), OLfwhm(*)
      Real Orfwhm(*), OAniso(*), OBack(*)
      Real DifEPS

      Integer i
      
      Write( 6, '(a,a40)') ' ***Save new parameters to ', fname 
      Write(11, '(a,a40)') ' ***Save new parameters to ', fname 
      Open(ifile, file=fname, status='UNKNOWN')
      Write(ifile, '(a79)') Title
      Write(ifile, '(a79)') IntFil
      Write(ifile, '(a79)') PrgNam
      Write(ifile, '(a25)') Method
      Write(ifile, '(i7, f10.6, g14.6)') nCycle, Dump, DifEPS
      Write(ifile, '(4f12.6)') ramda1, ramda2, QRange, IRatio 
      Write(ifile, '(2f10.4)') CalcX0, CalcX1
      Write(ifile, '(2f10.4)') OptX0, OptX1
      Do 15 i=1, 5
        Write(ifile, '(g14.6, i5, g14.6)')
     1       Back(i), idBack(i), Back(i)-OBack(i)
   15 Continue
      Write(ifile, '(i7)') nPeak
      Do 10 i=1, nPeak
        Write(ifile, '(g14.6, i5, g14.6)')
     1       Angle(i), idAng(i), Angle(i)-OAngle(i)
        Write(ifile, '(g14.6, i5, g14.6)')
     1       Height(i), idHei(i), Height(i)-OHeigh(i)
        Write(ifile, '(g14.6, i5, g14.6)')
     1       GFrac(i), idGFra(i), GFrac(i)-OGFrac(i)
        Write(ifile, '(g14.6, i5, g14.6)')
     1       Gfwhm(i), idGfwh(i), Gfwhm(i)-OGfwhm(i)
        Write(ifile, '(g14.6, i5, g14.6)')
     1       Lfwhm(i), idLfwh(i), Lfwhm(i)-OLfwhm(i)
        Write(ifile, '(g14.6, i5, g14.6)')
     1       rfwhm(i), idrfwh(i), rfwhm(i)-Orfwhm(i)
        Write(ifile, '(g14.6, i5, g14.6)')
     1       Aniso(i), idAnis(i), Aniso(i)-OAniso(i)
   10 Continue
      Write(ifile, '(i7)') nOData
      Do 20 i=1, nOData
        Write(ifile, '(2g14.6)') XOrg(i), YOrg(i)
   20 Continue            
      Close(ifile)
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine SvErr(ifile, fname, Title, nData, X, Y)
      Include 'xPeakFit.prm'
      Integer ifile
      Character*(*) fname, Title
      Integer nData
      Real X(*), Y(*)
      
      Integer i
      Real*8 S, sum, sum1, sum2
      
      Write(6, '(a,a20)') ' ***Save Error to ', fname
      Write(11, '(a,a20)') ' ***Save Error to ', fname
      Open(ifile, file=fname, status='UNKNOWN')
      Write(ifile, '(a79)') Title
      Write(ifile, '(i7)') nData
      S = 0.0
      sum = 0.0
      sum1 = 0.0
      sm2 = 0.0
      Do 10 i=1, nData
        Write(ifile, '(2g14.6)') X(i), Y(i)
        sum = sum + Y(i)
        sum1 = sum1 + Y(i) * X(i)
        sum2 = sum2 + Y(i) * X(i) * X(i)
        S = S + Y(i) * Y(i)
   10 Continue
      Write(ifile, '(a, g14.6)') ' sum=', sum
      Write(ifile, '(a, g14.6)') ' S=', S
      Write(ifile, '(a, g14.6)') ' Sigma=', sqrt(S/nData)
      Write(ifile, '(a, g14.6)') ' sum1=', sum1
      Write(ifile, '(a, g14.6)') ' sum2=', sum2
      End     
c**********************************************************************
c
c**********************************************************************
      Subroutine SvMtx(ifile, fname, nMtx, AMtx, BMtx)
      Include 'xPeakFit.prm'
      Integer ifile
      Character*(*) fname
      Integer nMtx
      Real*8 AMtx(MMtx, MMtx), BMtx(*)
      
      Integer i, j
      
      Write(6, '(a,a20)') ' ***Save Matrix elements to ', fname
      Write(11, '(a,a20)') ' ***Save Matrix elements to ', fname
      Open(ifile, file=fname, status='UNKNOWN')
      Write(ifile, '(i7)') nMtx
      Write(ifile, '(5g14.6)') (BMtx(i), i=1, nMtx)
      Write(ifile, *)
      Do 10 i=1, nMtx
        Write(ifile, '(5g14.6)') (AMtx(i,j), j=1, nMtx)
   10 Continue
      End     
c**********************************************************************
c
c**********************************************************************
      Subroutine SvPat(ifile, fname, Title, nData, XVal, YVal,
     1                 YCal, BG)
      Include 'xPeakFit.prm'
      Integer ifile, nData
      Real XVal(*), YVal(*), YCal(*), BG(*)
      Character*(*) fname, Title
      
      Open(ifile, file=fname, status='UNKNOWN')
      Write(ifile, '(a)') Title
      Write(ifile, '(i5, f10.6, 2i5)') 1, XVal(2)-XVal(1), 0, 1
      Write(ifile, '(i7, f10.6)') nData, XVal(1)
      Write(ifile, '(10i8)') (Int(YVal(i)), Int(YCal(i)), Int(BG(i)),
     1                        i=1, nData)
c      Do 200 i=1, nData
c        Write(ifile, '(f10.4, i8)') XVal(i), Int(YVal(i))
c  200 Continue      
      Close(ifile)
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine RDFile(ifile, fname, IntFil, Title, PrgNam, Method,
     1      nCycle, Dump, ramda1, ramda2, QRange, IRatio,
     2      CalcX0, CalcX1, OptX0, OptX1, nBack, Back, idBack,
     3      nPeak, nOData, Angle, Height, GFrac, Gfwhm, Lfwhm,
     4      rfwhm, Aniso, XOrg, YOrg, idAng, idHei, idGFra, idGfwh,
     5      idLfwh, idrfwh, idAnis, DifEPS)
      Include 'xPeakFit.prm'      
      Include 'xPeakFit.cmn'
      Integer ifile, nCycle
      Real Dump
      Character*(*) fname, IntFil
      Character*(*) Title, PrgNam, Method
      Real ramda1, ramda2, QRange, IRatio
      Real CalcX0, CalcX1, OptX0, OptX1
      Real Back(*)
      Integer idBack(*), nPeak, nOData, nBack
      Real Angle(*), Height(*), GFrac(*), Gfwhm(*), Lfwhm(*), rfwhm(*)
      Real Aniso(*), XOrg(*), YOrg(*)
      Integer idAng(*), idHei(*), idGFra(*), idGfwh(*), idLfwh(*)
      Integer idrfwh(*), idAnis(*)
      Real DifEPS
      
      Integer i
      Real Val
      
      Write(6, '(a,a40)') ' ***Read fitting parameters from', fname 
      Write(11, '(a,a40)') ' ***Read fitting parameters from', fname 
      nAsym = 7
      gAsym(1) = 1.0
      gAsym(2) = 4.0
      gAsym(3) = 2.0
      gAsym(4) = 4.0
      gAsym(5) = 2.0
      gAsym(6) = 4.0
      gAsym(7) = 1.0
      cAsym = 1.0 / 3.0 / (7.0 - 1.0)
      Do 5 i=1, 7
        fj(i) = ( Real(i-1)/Real(nAsym-1) )**2
    5 Continue   
      nBack = 5
      Open(ifile, file=fname, status='OLD')
      Read(ifile, '(a80)') Title
      Write(6, '(a,a70)') ' Title:', Title
      Write(11, '(a,a70)') ' Title:', Title
      Read(ifile, '(a80)') IntFil
      Read(ifile, '(a80)') PrgNam
      Write(6, '(a,a70)') ' Program:', PrgNam
      Write(11, '(a,a70)') ' Program:', PrgNam
      Read(ifile, '(a25)') Method
      Write(6, '(a,a25)') ' Optimize by ', Method
      Write(11, '(a,a25)') ' Optimize by ', Method
      Read(ifile, *) nCycle, Dump, DifEPS
      Write(6, '(a,i5)') ' Maximum number of iteration:', nCycle
      Write(11, '(a,i5)') ' Maximum number of iteration:', nCycle
      Write(6, '(a,f10.4)') ' Dumping factor:', Dump
      Write(11, '(a,f10.4)') ' Dumping factor:', Dump
      Write(6, '(a,g14.6)') ' EPS: ', DifEPS
      Write(11, '(a,g14.6)') ' EPS: ', DifEPS
      Read(ifile, *) ramda1, ramda2, QRange, IRatio 
      Write(6, '(a)') ' ramda1   ramda2   QRange   IRatio'
      Write(11, '(a)') ' ramda1   ramda2   QRange   IRatio'
      Write(6, '(4f12.6)') ramda1, ramda2, QRange, IRatio
      Write(11, '(4f12.6)') ramda1, ramda2, QRange, IRatio
      Read(ifile, *) CalcX0, CalcX1
      Write(6, '(a, 2f10.4)') ' Calculation :', CalcX0, CalcX1
      Write(11, '(a, 2f10.4)') ' Calculation :', CalcX0, CalcX1
      Read(ifile, *) OptX0, OptX1
      Write(6, '(a, 2f10.4)') ' Optimization:', OptX0, OptX1
      Write(11, '(a, 2f10.4)') ' Optimization:', OptX0, OptX1
      If(nBack .gt. MBack) Call JobEnd(' nBack too large')
      Do 15 i=1, nBack
        Read(ifile, *) Back(i), idBack(i), Val
c        Write(6, '(5x, g14.6, i2)') Back(i), idBack(i)
   15 Continue
      Write(6, '(a,3x,5i1)') ' Back ground parameters and ID',
     1      (idBack(i), i=1, 5)
      Write(11, '(a,3x,5i1)') ' Back ground parameters and ID',
     1      (idBack(i), i=1, 5)
      Write(6, '(3x,5g12.6)') (Back(i), i=1, 5)
      Write(11, '(3x,5g12.6)') (Back(i), i=1, 5)
      Read(ifile, *) nPeak
      Write(6, '(a, i5)') ' Number of Peaks to fit:', nPeak
      Write(11, '(a, i5)') ' Number of Peaks to fit:', nPeak
      If(nPeak .gt. MPeak) Call JobEnd(' nPeak too large')
      Do 10 i=1, nPeak
c        Write(6, '(a, i3)') '   Peak # ', i
        Read(ifile, *) Angle(i), idAng(i), Val
c        Write(6, '(5x, g14.6, i2)') Angle(i), idAng(i)
        Read(ifile, *) Height(i), idHei(i), Val
c        Write(6, '(5x, g14.6, i2)') Height(i), idHei(i)
        Read(ifile, *) GFrac(i), idGFra(i), Val
c        Write(6, '(5x, g14.6, i2)') GFrac(i), idGFra(i)
        Read(ifile, *) Gfwhm(i), idGfwh(i), Val
c        Write(6, '(5x, g14.6, i2)') Gfwhm(i), idGfwh(i)
        Read(ifile, *) Lfwhm(i), idLfwh(i), Val
c        Write(6, '(5x, g14.6, i2)') Lfwhm(i), idLfwh(i)
        Read(ifile, *) rfwhm(i), idrfwh(i), Val
c        Write(6, '(5x, g14.6, i2)') rfwhm(i), idrfwh(i)
        Read(ifile, *) Aniso(i), idAnis(i), Val
c        Write(6, '(5x, g14.6, i2)') Aniso(i), idAnis(i)
        Write(6, '(a, i3, 2x, 7i1, f10.4, f12.0, 5f8.4)') '  #', i,
     1       idAng(i), idHei(i), idGFra(i), idGfwh(i),
     2       idLfwh(i), idrfwh(i), idAnis(i),
     1       Angle(i), Height(i), GFrac(i), Gfwhm(i),
     2       Lfwhm(i), rfwhm(i), Aniso(i)
        Write(11, '(a, i3, 2x, 7i1, f10.4, f12.0, 5f8.4)') '  #', i,
     1       idAng(i), idHei(i), idGFra(i), idGfwh(i),
     2       idLfwh(i), idrfwh(i), idAnis(i),
     1       Angle(i), Height(i), GFrac(i), Gfwhm(i),
     2       Lfwhm(i), rfwhm(i), Aniso(i)
   10 Continue
      Read(ifile, *) nOData
      If(nOData .gt. MOData) Call JobEnd(' nOData too large')
      Do 20 i=1, nOData
        Read(ifile, *) XOrg(i), YOrg(i)
   20 Continue            
      Close(ifile)
      Return
      End